;
; NASM  CORE_C2BF.ASM
;

; ܂Ȃ
bits 32
section .text
align 16

%ifdef _WIN32
extern _sbox_k,_sbox_f
%else
extern sbox_k,sbox_f
%define _sbox_k sbox_k
%define _sbox_f sbox_f
%endif

global _check_c2_4key_mmx
global  check_c2_4key_mmx

_check_c2_4key_mmx:
check_c2_4key_mmx:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; WX^ޔ
	push       ebx;
	push       ecx;
	push       edx;
	push       esi;
	push       edi;
	push       ebp;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  - [Jϐ̈̊m
; Kvȗ̈
; kbe  - 16 byte   [esp+0`15]
; L    - 16 byte   [esp+16`31]
; R    - 16 byte   [esp+32`47]
; base - 4 byte    [esp+48]
;
	mov        eax, esp;
	sub        esp, 56;
	and        esp, -16;
; 烁C
	mov        [esp+48], eax;           // ϐݒ
	mov        esi, [eax+28];           // ϐݒ
	mov        eax, [esi+12];           // ϐݒ : kb
	pcmpeqb    mm7, mm7;                // ϐݒ 
	mov        ebp, 0ffh;               // ϐݒ
	mov        [esp+0], eax;            // ϐݒ : kbe[0]
	movd       mm0, eax;                // ϐݒ
	inc        eax;                     // ϐݒ
	mov        ebx, [esi+ 8];           // 1st round : ka
	mov        edi, _sbox_f;            // ϐݒ
	mov        [esp+4], eax;            // ϐݒ : kbe[1]
	movd       mm2, eax;                // ϐݒ
	inc        eax;                     // ϐݒ
	psrld      mm7, 24;                 // ϐݒ : 0x000000ff000000ff
	and        ebx, ebp;                // 1st round : ka & 0xff
	mov        [esp+8], eax;            // ϐݒ : kbe[2]
	movd       mm1, eax;                // ϐݒ
	inc        eax;                     // ϐݒ
	movd       mm4, [_sbox_k+ebx*4];    // 1st round
	movd       mm6, [esi+ 4];           // 1st round : LSB32(plaintext) : R
	mov        [esp+12], eax;           // ϐݒ : kbe[3]
	movd       mm3, eax;                // ϐݒ
	punpckldq  mm4, mm4;                // 1st round
	punpckldq  mm6, mm6;                // 1st round
	punpckldq  mm0, mm2;                // 1st round
	punpckldq  mm1, mm3;                // 1st round
	paddd      mm0, mm4;                // 1st round
	paddd      mm1, mm4;                // 1st round
	paddd      mm0, mm6;                // 1st round
	paddd      mm1, mm6;                // 1st round
	movq       mm2, mm0;                // 1st round
	movq       mm3, mm1;                // 1st round
	pand       mm2, mm7;                // 1st round
	pand       mm3, mm7;                // 1st round
	movd       eax, mm2;                // 1st round
	movd       ebx, mm3;                // 1st round
	psrlq      mm2, 30;                 // 1st round
	psrlq      mm3, 30;                 // 1st round
	movd       ecx, mm2;                // 1st round
	movd       edx, mm3;                // 1st round
	movd       mm2, [edi+eax*4];        // 1st round
	movd       mm3, [edi+ebx*4];        // 1st round
	movd       mm4, [edi+ecx];          // 1st round
	movd       mm5, [edi+edx];          // 1st round
	mov        eax, [esi+12];           // 2nd round : kb
	punpckldq  mm2, mm4;                // 1st round
	punpckldq  mm3, mm5;                // 1st round
	pxor       mm0, mm2;                // 1st round
	pxor       mm1, mm3;                // 1st round
	movq       mm2, mm0;                // 1st round
	movq       mm3, mm1;                // 1st round
	movq       mm4, mm0;                // 1st round
	movq       mm5, mm1;                // 1st round
	pslld      mm2, 9;                  // 1st round
	pslld      mm3, 9;                  // 1st round
	psrld      mm4, 23;                 // 1st round
	psrld      mm5, 23;                 // 1st round
	shr        eax, 15;                 // 2nd round
	por        mm2, mm4;                // 1st round
	por        mm3, mm5;                // 1st round
	movq       mm4, mm0;                // 1st round
	movq       mm5, mm1;                // 1st round
	pxor       mm0, mm2;                // 1st round
	pxor       mm1, mm3;                // 1st round
	movd       mm6, [esi+ 0];           // 1st round : MSB32(plaintext) : L
	and        eax, ebp;                // 2nd round
	movq       mm2, mm4;                // 1st round
	movq       mm3, mm5;                // 1st round
	pslld      mm4, 22;                 // 1st round
	pslld      mm5, 22;                 // 1st round
	psrld      mm2, 10;                 // 1st round
	psrld      mm3, 10;                 // 1st round
	punpckldq  mm6, mm6;                // 1st round
	xor        eax, 1;                  // 2nd round
	por        mm2, mm4;                // 1st round
	por        mm3, mm5;                // 1st round
	movd       mm4, [esi+ 8];           // 2nd round : ka
	movd       mm5, [_sbox_k+eax*4];    // 2nd round
	pxor       mm0, mm2;                // 1st round
	pxor       mm1, mm3;                // 1st round
	movq       mm2, [esp+0];            // 2nd round : kbe[0:1]
	movq       mm3, [esp+8];            // 2nd round : kbe[2:3]
	punpckldq  mm4, mm4;                // 2nd round
	paddd      mm0, mm6;                // 1st round
	paddd      mm1, mm6;                // 1st round
	pslld      mm2, 17;                 // 2nd round
	pslld      mm3, 17;                 // 2nd round
	psrld      mm4, 7;                  // 2nd round
	punpckldq  mm5, mm5;                // 2nd round
	movq       [esp+16+0], mm0;         // 1st round : L[0:1] ɏ
	movq       [esp+16+8], mm1;         // 1st round : L[2:3] ɏ
	por        mm2, mm4;                // 2nd round
	por        mm3, mm4;                // 2nd round
	paddd      mm2, mm5;                // 2nd round
	paddd      mm3, mm5;                // 2nd round
	paddd      mm0, mm2;                // 2nd round
	paddd      mm1, mm3;                // 2nd round
	movq       mm2, mm0;                // 2nd round
	movq       mm3, mm1;                // 2nd round
	pand       mm2, mm7;                // 2nd round
	pand       mm3, mm7;                // 2nd round
	movd       eax, mm2;                // 2nd round
	movd       ebx, mm3;                // 2nd round
	psrlq      mm2, 30;                 // 2nd round
	psrlq      mm3, 30;                 // 2nd round
	movd       ecx, mm2;                // 2nd round
	movd       edx, mm3;                // 2nd round
	movd       mm2, [edi+eax*4];        // 2nd round
	movd       mm3, [edi+ebx*4];        // 2nd round
	movd       mm4, [edi+ecx];          // 2nd round
	movd       mm5, [edi+edx];          // 2nd round
	mov        eax, [esi+ 8];           // 3rd round : ka
	mov        ebx, [esi+12];           // 3rd round : kb
	punpckldq  mm2, mm4;                // 2nd round
	punpckldq  mm3, mm5;                // 2nd round
	pxor       mm0, mm2;                // 2nd round
	pxor       mm1, mm3;                // 2nd round
	movq       mm2, mm0;                // 2nd round
	movq       mm3, mm1;                // 2nd round
	movq       mm4, mm0;                // 2nd round
	movq       mm5, mm1;                // 2nd round
	pslld      mm2, 9;                  // 2nd round
	pslld      mm3, 9;                  // 2nd round
	psrld      mm4, 23;                 // 2nd round
	psrld      mm5, 23;                 // 2nd round
	shr        eax, 22;                 // 3rd round
	shl        ebx, 2;                  // 3rd round
	por        mm2, mm4;                // 2nd round
	por        mm3, mm5;                // 2nd round
	movq       mm4, mm0;                // 2nd round
	movq       mm5, mm1;                // 2nd round
	movd       mm6, [esi+ 4];           // 2nd round : pb
	pxor       mm0, mm2;                // 2nd round
	pxor       mm1, mm3;                // 2nd round
	or         eax, ebx;                // 3rd round
	movq       mm2, mm4;                // 2nd round
	movq       mm3, mm5;                // 2nd round
	pslld      mm4, 22;                 // 2nd round
	pslld      mm5, 22;                 // 2nd round
	psrld      mm2, 10;                 // 2nd round
	psrld      mm3, 10;                 // 2nd round
	punpckldq  mm6, mm6;                // 2nd round
	and        eax, ebp;                // 3rd round
	por        mm2, mm4;                // 2nd round
	por        mm3, mm5;                // 2nd round
	xor        eax, 2;                  // 3rd round
	pxor       mm0, mm2;                // 2nd round
	pxor       mm1, mm3;                // 2nd round
	movd       mm2, [esi+ 8];           // 3rd round
	movd       mm3, [esi+12];           // 3rd round
	paddd      mm0, mm6;                // 2nd round
	paddd      mm1, mm6;                // 2nd round
	pslld      mm2, 10;                 // 3rd round
	psrld      mm3, 22;                 // 3rd round
	movq       [esp+32+0], mm0;         // 2nd round : R[0:1] ɏ
	movq       [esp+32+8], mm1;         // 2nd round : R[2:3] ɏ
	por        mm2, mm3;                // 3rd round
	movd       mm3, [_sbox_k+eax*4];    // 3rd round
	movd       mm4, [_sbox_k+eax*4+16]; // 3rd round
	movd       mm5, [_sbox_k+eax*4+32]; // 3rd round
	movd       mm6, [_sbox_k+eax*4+48]; // 3rd round
	punpckldq  mm2, mm2;                // 3rd round
	punpckldq  mm3, mm4;                // 3rd round
	punpckldq  mm5, mm6;                // 3rd round
	paddd      mm3, mm2;                // 3rd round
	paddd      mm5, mm2;                // 3rd round
	paddd      mm0, mm3;                // 3rd round
	paddd      mm1, mm5;                // 3rd round
	movq       mm2, mm0;                // 3rd round
	movq       mm3, mm1;                // 3rd round
	pand       mm2, mm7;                // 3rd round
	pand       mm3, mm7;                // 3rd round
	movd       eax, mm2;                // 3rd round
	movd       ebx, mm3;                // 3rd round
	psrlq      mm2, 30;                 // 3rd round
	psrlq      mm3, 30;                 // 3rd round
	movd       ecx, mm2;                // 3rd round
	movd       edx, mm3;                // 3rd round
	movd       mm2, [edi+eax*4];        // 3rd round
	movd       mm3, [edi+ebx*4];        // 3rd round
	movd       mm4, [edi+ecx];          // 3rd round
	movd       mm5, [edi+edx];          // 3rd round
	mov        eax, [esi+ 8];           // 4th round : ka
	punpckldq  mm2, mm4;                // 3rd round
	punpckldq  mm3, mm5;                // 3rd round
	pxor       mm0, mm2;                // 3rd round
	pxor       mm1, mm3;                // 3rd round
	movq       mm2, mm0;                // 3rd round
	movq       mm3, mm1;                // 3rd round
	movq       mm4, mm0;                // 3rd round
	movq       mm5, mm1;                // 3rd round
	pslld      mm2, 9;                  // 3rd round
	pslld      mm3, 9;                  // 3rd round
	psrld      mm4, 23;                 // 3rd round
	psrld      mm5, 23;                 // 3rd round
	shr        eax, 5;                  // 4th round
	por        mm2, mm4;                // 3rd round
	por        mm3, mm5;                // 3rd round
	movq       mm4, mm0;                // 3rd round
	movq       mm5, mm1;                // 3rd round
	pxor       mm0, mm2;                // 3rd round
	pxor       mm1, mm3;                // 3rd round
	and        eax, ebp;                // 4th round
	movq       mm2, mm4;                // 3rd round
	movq       mm3, mm5;                // 3rd round
	pslld      mm4, 22;                 // 3rd round
	pslld      mm5, 22;                 // 3rd round
	psrld      mm2, 10;                 // 3rd round
	psrld      mm3, 10;                 // 3rd round
	xor        eax, 3;                  // 4th round
	por        mm2, mm4;                // 3rd round
	por        mm3, mm5;                // 3rd round
	movd       mm4, [esi+12];           // 4th round : kb
	movd       mm5, [esi+ 8];           // 4th round : ka
	pxor       mm0, mm2;                // 3rd round
	pxor       mm1, mm3;                // 3rd round
	psrld      mm4, 5;                  // 4th round
	pslld      mm5, 27;                 // 4th round
	movd       mm6, [_sbox_k+eax*4];    // 4th round
	por        mm4, mm5;                // 4th round
	paddd      mm0, [esp+16+0];         // 3rd round
	paddd      mm4, mm6;                // 4th round
	paddd      mm1, [esp+16+8];         // 3rd round
	punpckldq  mm4, mm4;                // 4th round
	movq       [esp+16+0], mm0;         // 3rd round : L[0:1] ɏ
	movq       [esp+16+8], mm1;         // 3rd round : L[2:3] ɏ
	paddd      mm0, mm4;                // 4th round
	paddd      mm1, mm4;                // 4th round
	movq       mm2, mm0;                // 4th round
	movq       mm3, mm1;                // 4th round
	pand       mm2, mm7;                // 4th round
	pand       mm3, mm7;                // 4th round
	movd       eax, mm2;                // 4th round
	movd       ebx, mm3;                // 4th round
	psrlq      mm2, 30;                 // 4th round
	psrlq      mm3, 30;                 // 4th round
	movd       ecx, mm2;                // 4th round
	movd       edx, mm3;                // 4th round
	movd       mm2, [edi+eax*4];        // 4th round
	movd       mm3, [edi+ebx*4];        // 4th round
	movd       mm4, [edi+ecx];          // 4th round
	movd       mm5, [edi+edx];          // 4th round
	mov        eax, [esi+12];           // 5th round : kb
	punpckldq  mm2, mm4;                // 4th round
	punpckldq  mm3, mm5;                // 4th round
	pxor       mm0, mm2;                // 4th round
	pxor       mm1, mm3;                // 4th round
	movq       mm2, mm0;                // 4th round
	movq       mm3, mm1;                // 4th round
	movq       mm4, mm0;                // 4th round
	movq       mm5, mm1;                // 4th round
	pslld      mm2, 9;                  // 4th round
	pslld      mm3, 9;                  // 4th round
	psrld      mm4, 23;                 // 4th round
	psrld      mm5, 23;                 // 4th round
	shr        eax, 20;                 // 5th round
	por        mm2, mm4;                // 4th round
	por        mm3, mm5;                // 4th round
	movq       mm4, mm0;                // 4th round
	movq       mm5, mm1;                // 4th round
	pxor       mm0, mm2;                // 4th round
	pxor       mm1, mm3;                // 4th round
	and        eax, ebp;                // 5th round
	movq       mm2, mm4;                // 4th round
	movq       mm3, mm5;                // 4th round
	pslld      mm4, 22;                 // 4th round
	pslld      mm5, 22;                 // 4th round
	psrld      mm2, 10;                 // 4th round
	psrld      mm3, 10;                 // 4th round
	xor        eax, 4;                  // 5th round
	por        mm2, mm4;                // 4th round
	por        mm3, mm5;                // 4th round
	movd       mm6, [_sbox_k+eax*4];    // 5th round
	movq       mm4, [esp+0];            // 5th round : kbe[0:1]
	movq       mm5, [esp+8];            // 5th round : kbe[2:3]
	pxor       mm0, mm2;                // 4th round
	pxor       mm1, mm3;                // 4th round
	movd       mm3, [esi+ 8];           // 5th round : ka
	punpckldq  mm6, mm6;                // 5th round
	paddd      mm0, [esp+32+0];         // 4th round
	paddd      mm1, [esp+32+8];         // 4th round
	punpckldq  mm3, mm3;                // 5th round
	pslld      mm4, 12;                 // 5th round
	pslld      mm5, 12;                 // 5th round
	psrld      mm3, 12;                 // 5th round
	movq       [esp+32+0], mm0;         // 4th round : R[0:1] ɏ
	movq       [esp+32+8], mm1;         // 4th round : R[2:3] ɏ
	por        mm4, mm3;                // 5th round
	por        mm5, mm3;                // 5th round
	paddd      mm4, mm6;                // 5th round
	paddd      mm5, mm6;                // 5th round
	paddd      mm0, mm4;                // 5th round
	paddd      mm1, mm5;                // 5th round
	movq       mm2, mm0;                // 5th round
	movq       mm3, mm1;                // 5th round
	pand       mm2, mm7;                // 5th round
	pand       mm3, mm7;                // 5th round
	movd       eax, mm2;                // 5th round
	movd       ebx, mm3;                // 5th round
	psrlq      mm2, 30;                 // 5th round
	psrlq      mm3, 30;                 // 5th round
	movd       ecx, mm2;                // 5th round
	movd       edx, mm3;                // 5th round
	movd       mm2, [edi+eax*4];        // 5th round
	movd       mm3, [edi+ebx*4];        // 5th round
	movd       mm4, [edi+ecx];          // 5th round
	movd       mm5, [edi+edx];          // 5th round
	mov        eax, [esi+12];           // 6th round : kb
	punpckldq  mm2, mm4;                // 5th round
	punpckldq  mm3, mm5;                // 5th round
	pxor       mm0, mm2;                // 5th round
	pxor       mm1, mm3;                // 5th round
	movq       mm2, mm0;                // 5th round
	movq       mm3, mm1;                // 5th round
	movq       mm4, mm0;                // 5th round
	movq       mm5, mm1;                // 5th round
	pslld      mm2, 9;                  // 5th round
	pslld      mm3, 9;                  // 5th round
	psrld      mm4, 23;                 // 5th round
	psrld      mm5, 23;                 // 5th round
	shr        eax, 3;                  // 6th round
	por        mm2, mm4;                // 5th round
	por        mm3, mm5;                // 5th round
	movq       mm4, mm0;                // 5th round
	movq       mm5, mm1;                // 5th round
	pxor       mm0, mm2;                // 5th round
	pxor       mm1, mm3;                // 5th round
	and        eax, ebp;                // 6th round
	movq       mm2, mm4;                // 5th round
	movq       mm3, mm5;                // 5th round
	pslld      mm4, 22;                 // 5th round
	pslld      mm5, 22;                 // 5th round
	psrld      mm2, 10;                 // 5th round
	psrld      mm3, 10;                 // 5th round
	xor        eax, 5;                  // 6th round
	por        mm2, mm4;                // 5th round
	por        mm3, mm5;                // 5th round
	movd       mm6, [_sbox_k+eax*4];    // 6th round
	movd       mm4, [esi+ 8];           // 6th round : ka
	movd       mm5, [esi+12];           // 6th round : kb
	pxor       mm0, mm2;                // 5th round
	pxor       mm1, mm3;                // 5th round
	movq       mm2, [esp+0];            // 6th round : kbe[0:1]
	movq       mm3, [esp+8];            // 6th round : kbe[2:3]
	pslld      mm4, 5;                  // 6th round
	psrld      mm5, 27;                 // 6th round
	paddd      mm0, [esp+16+0];         // 5th round
	paddd      mm1, [esp+16+8];         // 5th round
	punpckldq  mm6, mm6;                // 6th round
	por        mm4, mm5;                // 6th round
	pslld      mm2, 29;                 // 6th round
	pslld      mm3, 29;                 // 6th round
	punpckldq  mm4, mm4;                // 6th round
	movq       [esp+16+0], mm0;         // 5th round : L[0:1] ɏ
	movq       [esp+16+8], mm1;         // 5th round : L[2:3] ɏ
	por        mm2, mm4;                // 6th round
	por        mm3, mm4;                // 6th round
	paddd      mm2, mm6;                // 6th round
	paddd      mm3, mm6;                // 6th round
	paddd      mm0, mm2;                // 6th round
	paddd      mm1, mm3;                // 6th round
	movq       mm2, mm0;                // 6th round
	movq       mm3, mm1;                // 6th round
	pand       mm2, mm7;                // 6th round
	pand       mm3, mm7;                // 6th round
	movd       eax, mm2;                // 6th round
	movd       ebx, mm3;                // 6th round
	psrlq      mm2, 30;                 // 6th round
	psrlq      mm3, 30;                 // 6th round
	movd       ecx, mm2;                // 6th round
	movd       edx, mm3;                // 6th round
	movd       mm2, [edi+eax*4];        // 6th round
	movd       mm3, [edi+ebx*4];        // 6th round
	movd       mm4, [edi+ecx];          // 6th round
	movd       mm5, [edi+edx];          // 6th round
	mov        eax, [esi+ 8];           // 7th round : ka
	punpckldq  mm2, mm4;                // 6th round
	punpckldq  mm3, mm5;                // 6th round
	pxor       mm0, mm2;                // 6th round
	pxor       mm1, mm3;                // 6th round
	movq       mm2, mm0;                // 6th round
	movq       mm3, mm1;                // 6th round
	movq       mm4, mm0;                // 6th round
	movq       mm5, mm1;                // 6th round
	pslld      mm2, 9;                  // 6th round
	pslld      mm3, 9;                  // 6th round
	psrld      mm4, 23;                 // 6th round
	psrld      mm5, 23;                 // 6th round
	shr        eax, 10;                 // 7th round
	por        mm2, mm4;                // 6th round
	por        mm3, mm5;                // 6th round
	movq       mm4, mm0;                // 6th round
	movq       mm5, mm1;                // 6th round
	and        eax, ebp;                // 7th round
	pxor       mm0, mm2;                // 6th round
	pxor       mm1, mm3;                // 6th round
	movq       mm2, mm4;                // 6th round
	movq       mm3, mm5;                // 6th round
	pslld      mm4, 22;                 // 6th round
	pslld      mm5, 22;                 // 6th round
	psrld      mm2, 10;                 // 6th round
	psrld      mm3, 10;                 // 6th round
	xor        eax, 6;                  // 7th round
	por        mm2, mm4;                // 6th round
	por        mm3, mm5;                // 6th round
	movd       mm6, [_sbox_k+eax*4];    // 7th round
	movd       mm4, [esi+ 8];           // 7th round : ka
	movd       mm5, [esi+12];           // 7th round : kb
	pxor       mm0, mm2;                // 6th round
	pxor       mm1, mm3;                // 6th round
	pslld      mm4, 22;                 // 7th round
	psrld      mm5, 10;                 // 7th round
	paddd      mm0, [esp+32+0];         // 6th round
	por        mm4, mm5;                // 7th round
	paddd      mm1, [esp+32+8];         // 6th round
	paddd      mm4, mm6;                // 7th round
	movq       [esp+32+0], mm0;         // 6th round : R[0:1] ɏ
	punpckldq  mm4, mm4;                // 7th round
	movq       [esp+32+8], mm1;         // 6th round : R[2:3] ɏ
	paddd      mm0, mm4;                // 7th round
	paddd      mm1, mm4;                // 7th round
	movq       mm2, mm0;                // 7th round
	movq       mm3, mm1;                // 7th round
	pand       mm2, mm7;                // 7th round
	pand       mm3, mm7;                // 7th round
	movd       eax, mm2;                // 7th round
	movd       ebx, mm3;                // 7th round
	psrlq      mm2, 30;                 // 7th round
	psrlq      mm3, 30;                 // 7th round
	movd       ecx, mm2;                // 7th round
	movd       edx, mm3;                // 7th round
	movd       mm2, [edi+eax*4];        // 7th round
	movd       mm3, [edi+ebx*4];        // 7th round
	movd       mm4, [edi+ecx];          // 7th round
	movd       mm5, [edi+edx];          // 7th round
	mov        eax, [esi+ 8];           // 8th round : ka
	mov        ebx, [esi+12];           // 8th round : kb
	punpckldq  mm2, mm4;                // 7th round
	punpckldq  mm3, mm5;                // 7th round
	pxor       mm0, mm2;                // 7th round
	pxor       mm1, mm3;                // 7th round
	movq       mm2, mm0;                // 7th round
	movq       mm3, mm1;                // 7th round
	movq       mm4, mm0;                // 7th round
	movq       mm5, mm1;                // 7th round
	pslld      mm2, 9;                  // 7th round
	pslld      mm3, 9;                  // 7th round
	psrld      mm4, 23;                 // 7th round
	psrld      mm5, 23;                 // 7th round
	shl        eax, 7;                  // 8th round
	shr        ebx, 25;                 // 8th round
	por        mm2, mm4;                // 7th round
	por        mm3, mm5;                // 7th round
	movq       mm4, mm0;                // 7th round
	movq       mm5, mm1;                // 7th round
	pxor       mm0, mm2;                // 7th round
	pxor       mm1, mm3;                // 7th round
	or         eax, ebx;                // 8th round
	movq       mm2, mm4;                // 7th round
	movq       mm3, mm5;                // 7th round
	and        eax, ebp;                // 8th round
	pslld      mm4, 22;                 // 7th round
	pslld      mm5, 22;                 // 7th round
	psrld      mm2, 10;                 // 7th round
	psrld      mm3, 10;                 // 7th round
	xor        eax, 7;                  // 8th round
	por        mm2, mm4;                // 7th round
	por        mm3, mm5;                // 7th round
	movd       mm6, [_sbox_k+eax*4];    // 8th round
	movq       mm4, [esp+0];            // 8th round : kbe[0:1]
	movq       mm5, [esp+8];            // 8th round : kbe[2:3]
	pxor       mm0, mm2;                // 7th round
	pxor       mm1, mm3;                // 7th round
	movd       mm2, [esi+ 8];           // 8th round : ka
	pslld      mm4, 7;                  // 8th round
	pslld      mm5, 7;                  // 8th round
	psrld      mm2, 17;                 // 8th round
	paddd      mm0, [esp+16+0];         // 7th round
	paddd      mm1, [esp+16+8];         // 7th round
	punpckldq  mm6, mm6;                // 8th round
	punpckldq  mm2, mm2;                // 8th round
	movq       [esp+16+0], mm0;         // 7th round : L[0:1] ɏ
	movq       [esp+16+8], mm1;         // 7th round : L[2:3] ɏ
	por        mm4, mm2;                // 8th round
	por        mm5, mm2;                // 8th round
	paddd      mm4, mm6;                // 8th round
	paddd      mm5, mm6;                // 8th round
	paddd      mm0, mm4;                // 8th round
	paddd      mm1, mm5;                // 8th round
	movq       mm2, mm0;                // 8th round
	movq       mm3, mm1;                // 8th round
	pand       mm2, mm7;                // 8th round
	pand       mm3, mm7;                // 8th round
	movd       eax, mm2;                // 8th round
	movd       ebx, mm3;                // 8th round
	psrlq      mm2, 30;                 // 8th round
	psrlq      mm3, 30;                 // 8th round
	movd       ecx, mm2;                // 8th round
	movd       edx, mm3;                // 8th round
	movd       mm2, [edi+eax*4];        // 8th round
	movd       mm3, [edi+ebx*4];        // 8th round
	movd       mm4, [edi+ecx];          // 8th round
	movd       mm5, [edi+edx];          // 8th round
	mov        eax, [esi+12];           // 9th round : kb
	punpckldq  mm2, mm4;                // 8th round
	punpckldq  mm3, mm5;                // 8th round
	pxor       mm0, mm2;                // 8th round
	pxor       mm1, mm3;                // 8th round
	movq       mm2, mm0;                // 8th round
	movq       mm3, mm1;                // 8th round
	movq       mm4, mm0;                // 8th round
	movq       mm5, mm1;                // 8th round
	pslld      mm2, 9;                  // 8th round
	pslld      mm3, 9;                  // 8th round
	psrld      mm4, 23;                 // 8th round
	psrld      mm5, 23;                 // 8th round
	shr        eax, 8;                  // 9th round
	por        mm2, mm4;                // 8th round
	por        mm3, mm5;                // 8th round
	movq       mm4, mm0;                // 8th round
	movq       mm5, mm1;                // 8th round
	pxor       mm0, mm2;                // 8th round
	pxor       mm1, mm3;                // 8th round
	and        eax, ebp;                // 9th round
	movq       mm2, mm4;                // 8th round
	movq       mm3, mm5;                // 8th round
	xor        eax, 8;                  // 9th round
	pslld      mm4, 22;                 // 8th round
	pslld      mm5, 22;                 // 8th round
	psrld      mm2, 10;                 // 8th round
	psrld      mm3, 10;                 // 8th round
	movd       mm6, [_sbox_k+eax*4];    // 9th round
	por        mm2, mm4;                // 8th round
	por        mm3, mm5;                // 8th round
	movq       mm4, [esp+0];            // 9th round : kbe[0:1]
	movq       mm5, [esp+8];            // 9th round : kbe[2:3]
	pxor       mm0, mm2;                // 8th round
	pxor       mm1, mm3;                // 8th round
	movd       mm2, [esi+ 8];           // 9th round : ka
	pslld      mm4, 24;                 // 9th round
	pslld      mm5, 24;                 // 9th round
	paddd      mm0, [esp+32+0];         // 8th round
	paddd      mm1, [esp+32+8];         // 8th round
	punpckldq  mm6, mm6;                // 9th round
	punpckldq  mm2, mm2;                // 9th round
	movq       [esp+32+0], mm0;         // 8th round : R[0:1] ɏ
	movq       [esp+32+8], mm1;         // 8th round : R[2:3] ɏ
	por        mm4, mm2;                // 9th round
	por        mm5, mm2;                // 9th round
	paddd      mm4, mm6;                // 9th round
	paddd      mm5, mm6;                // 9th round
	movd       mm6, [esi+48];           // check phase : cb[0]
	paddd      mm0, mm4;                // 9th round
	paddd      mm1, mm5;                // 9th round
	movq       mm2, mm0;                // 9th round
	movq       mm3, mm1;                // 9th round
	pand       mm2, mm7;                // 9th round
	pand       mm3, mm7;                // 9th round
	punpckldq  mm6, mm6;                // check phase
	movd       eax, mm2;                // 9th round
	movd       ebx, mm3;                // 9th round
	psrlq      mm2, 30;                 // 9th round
	psrlq      mm3, 30;                 // 9th round
	movd       ecx, mm2;                // 9th round
	movd       edx, mm3;                // 9th round
	movd       mm2, [edi+eax*4];        // 9th round
	movd       mm3, [edi+ebx*4];        // 9th round
	movd       mm4, [edi+ecx];          // 9th round
	movd       mm5, [edi+edx];          // 9th round
	punpckldq  mm2, mm4;                // 9th round
	punpckldq  mm3, mm5;                // 9th round
	pxor       mm0, mm2;                // 9th round
	pxor       mm1, mm3;                // 9th round
	movq       mm2, mm0;                // 9th round
	movq       mm3, mm1;                // 9th round
	movq       mm4, mm0;                // 9th round
	movq       mm5, mm1;                // 9th round
	pslld      mm2, 9;                  // 9th round
	pslld      mm3, 9;                  // 9th round
	psrld      mm4, 23;                 // 9th round
	psrld      mm5, 23;                 // 9th round
	por        mm2, mm4;                // 9th round
	por        mm3, mm5;                // 9th round
	movq       mm4, mm0;                // 9th round
	movq       mm5, mm1;                // 9th round
	pxor       mm0, mm2;                // 9th round
	pxor       mm1, mm3;                // 9th round
	movq       mm2, mm4;                // 9th round
	movq       mm3, mm5;                // 9th round
	pslld      mm4, 22;                 // 9th round
	pslld      mm5, 22;                 // 9th round
	psrld      mm2, 10;                 // 9th round
	psrld      mm3, 10;                 // 9th round
	por        mm2, mm4;                // 9th round
	por        mm3, mm5;                // 9th round
	movd       mm5, [esi+52];           // check phase : cb[1]
	pxor       mm0, mm2;                // 9th round
	pxor       mm1, mm3;                // 9th round
	movq       mm2, mm6;                // check phase
	paddd      mm0, [esp+16+0];         // 9th round
	paddd      mm1, [esp+16+8];         // 9th round
	punpckldq  mm5, mm5;                // check phase
	movq       [esp+16+0], mm0;         // 9th round : L[0:1] ɏ
	movq       [esp+16+8], mm1;         // 9th round : L[2:3] ɏ
	movq       mm3, mm5;                // check phase
	pcmpeqd    mm6, mm0;                // check phase
	pcmpeqd    mm5, mm0;                // check phase
	pcmpeqd    mm2, mm1;                // check phase
	pcmpeqd    mm3, mm1;                // check phase
	por        mm6, mm5;                // check phase
	movd       mm4, [esi+56];           // check phase : cb[2]
	por        mm6, mm2;                // check phase
	movd       mm5, [esi+60];           // check phase : cb[3]
	por        mm6, mm3;                // check phase
	punpckldq  mm4, mm4;                // check phase
	punpckldq  mm5, mm5;                // check phase
	movq       mm2, mm4;                // check phase
	movq       mm3, mm5;                // check phase
	pcmpeqd    mm4, mm0;                // check phase
	pcmpeqd    mm5, mm0;                // check phase
	pcmpeqd    mm2, mm1;                // check phase
	pcmpeqd    mm3, mm1;                // check phase
	por        mm6, mm4;                // check phase
	movd       mm4, [esi+64];           // check phase : cb[4]
	por        mm6, mm5;                // check phase
	movd       mm5, [esi+68];           // check phase : cb[5]
	por        mm6, mm2;                // check phase
	punpckldq  mm4, mm4;                // check phase
	por        mm6, mm3;                // check phase
	punpckldq  mm5, mm5;                // check phase
	movq       mm2, mm4;                // check phase
	movq       mm3, mm5;                // check phase
	pcmpeqd    mm4, mm0;                // check phase
	pcmpeqd    mm5, mm0;                // check phase
	pcmpeqd    mm2, mm1;                // check phase
	pcmpeqd    mm3, mm1;                // check phase
	por        mm6, mm4;                // check phase
	movd       mm4, [esi+72];           // check phase : cb[6]
	por        mm6, mm5;                // check phase
	movd       mm5, [esi+76];           // check phase : cb[7]
	por        mm6, mm2;                // check phase
	punpckldq  mm4, mm4;                // check phase
	por        mm6, mm3;                // check phase
	punpckldq  mm5, mm5;                // check phase
	movq       mm2, mm4;                // check phase
	movq       mm3, mm5;                // check phase
	pcmpeqd    mm4, mm0;                // check phase
	pcmpeqd    mm5, mm0;                // check phase
	pcmpeqd    mm2, mm1;                // check phase
	pcmpeqd    mm3, mm1;                // check phase
	por        mm6, mm4;                // check phase
	por        mm2, mm3;                // check phase
	por        mm6, mm5;                // check phase
	por        mm6, mm2;                // check phase
	packsswb   mm6, mm6;                // check phase
	movd       eax, mm6;                // check phase
	test       eax, eax;                // check phase
	jz near CHECK_C2_4KEY_MMX_LAST;
	mov        eax, [esi+ 8];           // 10th round : ka
	movd       mm2, [esi+ 8];           // 10th round
	movd       mm3, [esi+12];           // 10th round
	shr        eax, 15;                 // 10th round
	pslld      mm2, 17;                 // 10th round
	psrld      mm3, 15;                 // 10th round
	and        eax, ebp;                // 10th round
	xor        eax, 9;                  // 10th round
	por        mm2, mm3;                // 10th round
	movd       mm4, [_sbox_k+eax*4];    // 10th round
	paddd      mm2, mm4;                // 10th round
	punpckldq  mm2, mm2;                // 10th round
	paddd      mm0, mm2;                // 10th round
	paddd      mm1, mm2;                // 10th round
	movq       mm2, mm0;                // 10th round
	movq       mm3, mm1;                // 10th round
	pand       mm2, mm7;                // 10th round
	pand       mm3, mm7;                // 10th round
	movd       eax, mm2;                // 10th round
	movd       ebx, mm3;                // 10th round
	psrlq      mm2, 30;                 // 10th round
	psrlq      mm3, 30;                 // 10th round
	movd       ecx, mm2;                // 10th round
	movd       edx, mm3;                // 10th round
	movd       mm2, [edi+eax*4];        // 10th round
	movd       mm3, [edi+ebx*4];        // 10th round
	movd       mm4, [edi+ecx];          // 10th round
	movd       mm5, [edi+edx];          // 10th round
	punpckldq  mm2, mm4;                // 10th round
	punpckldq  mm3, mm5;                // 10th round
	pxor       mm0, mm2;                // 10th round
	pxor       mm1, mm3;                // 10th round
	movq       mm2, mm0;                // 10th round
	movq       mm3, mm1;                // 10th round
	movq       mm4, mm0;                // 10th round
	movq       mm5, mm1;                // 10th round
	pslld      mm2, 9;                  // 10th round
	pslld      mm3, 9;                  // 10th round
	psrld      mm4, 23;                 // 10th round
	psrld      mm5, 23;                 // 10th round
	por        mm2, mm4;                // 10th round
	por        mm3, mm5;                // 10th round
	movq       mm4, mm0;                // 10th round
	movq       mm5, mm1;                // 10th round
	pxor       mm0, mm2;                // 10th round
	pxor       mm1, mm3;                // 10th round
	movq       mm2, mm4;                // 10th round
	movq       mm3, mm5;                // 10th round
	pslld      mm4, 22;                 // 10th round
	pslld      mm5, 22;                 // 10th round
	psrld      mm2, 10;                 // 10th round
	psrld      mm3, 10;                 // 10th round
	por        mm2, mm4;                // 10th round
	por        mm3, mm5;                // 10th round
	pxor       mm0, mm2;                // 10th round
	pxor       mm1, mm3;                // 10th round
	paddd      mm0, [esp+32+0];         // 10th round  : L
	paddd      mm1, [esp+32+8];         // 10th round  : L
	movq       mm2, [esp+16+0];         // final phase : R
	movq       mm3, [esp+16+8];         // final phase : R
	movd       mm4, [esi+16];           // final phase : ca[0]
	movd       mm6, [esi+48];           // final phase : cb[0]
	punpckldq  mm4, mm4;                // final phase
	punpckldq  mm6, mm6;                // final phase
	movq       mm5, mm4;                // final phase
	movq       mm7, mm6;                // final phase
	pcmpeqd    mm4, mm0;                // final phase
	pcmpeqd    mm5, mm1;                // final phase
	pcmpeqd    mm6, mm2;                // final phase
	pcmpeqd    mm7, mm3;                // final phase
	packssdw   mm4, mm5;                // final phase
	packssdw   mm6, mm7;                // final phase
	pand       mm4, mm6;                // final phase
	psrlw      mm4, 15;                 // final phase
	packuswb   mm4, mm4;                // final phase
	movd       eax, mm4;                // final phase
	movd       mm4, [esi+20];           // final phase : ca[1]
	movd       mm6, [esi+52];           // final phase : cb[1]
	punpckldq  mm4, mm4;                // final phase
	punpckldq  mm6, mm6;                // final phase
	movq       mm5, mm4;                // final phase
	movq       mm7, mm6;                // final phase
	pcmpeqd    mm4, mm0;                // final phase
	pcmpeqd    mm5, mm1;                // final phase
	pcmpeqd    mm6, mm2;                // final phase
	pcmpeqd    mm7, mm3;                // final phase
	packssdw   mm4, mm5;                // final phase
	packssdw   mm6, mm7;                // final phase
	pand       mm4, mm6;                // final phase
	psrlw      mm4, 15;                 // final phase
	psllw      mm4, 1;                  // final phase
	packuswb   mm4, mm4;                // final phase
	movd       ebx, mm4;                // final phase
	or         eax, ebx;                // final phase
	movd       mm4, [esi+24];           // final phase : ca[2]
	movd       mm6, [esi+56];           // final phase : cb[2]
	punpckldq  mm4, mm4;                // final phase
	punpckldq  mm6, mm6;                // final phase
	movq       mm5, mm4;                // final phase
	movq       mm7, mm6;                // final phase
	pcmpeqd    mm4, mm0;                // final phase
	pcmpeqd    mm5, mm1;                // final phase
	pcmpeqd    mm6, mm2;                // final phase
	pcmpeqd    mm7, mm3;                // final phase
	packssdw   mm4, mm5;                // final phase
	packssdw   mm6, mm7;                // final phase
	pand       mm4, mm6;                // final phase
	psrlw      mm4, 15;                 // final phase
	psllw      mm4, 2;                  // final phase
	packuswb   mm4, mm4;                // final phase
	movd       ebx, mm4;                // final phase
	or         eax, ebx;                // final phase
	movd       mm4, [esi+28];           // final phase : ca[3]
	movd       mm6, [esi+60];           // final phase : cb[3]
	punpckldq  mm4, mm4;                // final phase
	punpckldq  mm6, mm6;                // final phase
	movq       mm5, mm4;                // final phase
	movq       mm7, mm6;                // final phase
	pcmpeqd    mm4, mm0;                // final phase
	pcmpeqd    mm5, mm1;                // final phase
	pcmpeqd    mm6, mm2;                // final phase
	pcmpeqd    mm7, mm3;                // final phase
	packssdw   mm4, mm5;                // final phase
	packssdw   mm6, mm7;                // final phase
	pand       mm4, mm6;                // final phase
	psrlw      mm4, 15;                 // final phase
	psllw      mm4, 3;                  // final phase
	packuswb   mm4, mm4;                // final phase
	movd       ebx, mm4;                // final phase
	or         eax, ebx;                // final phase
	movd       mm4, [esi+32];           // final phase : ca[4]
	movd       mm6, [esi+64];           // final phase : cb[4]
	punpckldq  mm4, mm4;                // final phase
	punpckldq  mm6, mm6;                // final phase
	movq       mm5, mm4;                // final phase
	movq       mm7, mm6;                // final phase
	pcmpeqd    mm4, mm0;                // final phase
	pcmpeqd    mm5, mm1;                // final phase
	pcmpeqd    mm6, mm2;                // final phase
	pcmpeqd    mm7, mm3;                // final phase
	packssdw   mm4, mm5;                // final phase
	packssdw   mm6, mm7;                // final phase
	pand       mm4, mm6;                // final phase
	psrlw      mm4, 15;                 // final phase
	psllw      mm4, 4;                  // final phase
	packuswb   mm4, mm4;                // final phase
	movd       ebx, mm4;                // final phase
	or         eax, ebx;                // final phase
	movd       mm4, [esi+36];           // final phase : ca[5]
	movd       mm6, [esi+68];           // final phase : cb[5]
	punpckldq  mm4, mm4;                // final phase
	punpckldq  mm6, mm6;                // final phase
	movq       mm5, mm4;                // final phase
	movq       mm7, mm6;                // final phase
	pcmpeqd    mm4, mm0;                // final phase
	pcmpeqd    mm5, mm1;                // final phase
	pcmpeqd    mm6, mm2;                // final phase
	pcmpeqd    mm7, mm3;                // final phase
	packssdw   mm4, mm5;                // final phase
	packssdw   mm6, mm7;                // final phase
	pand       mm4, mm6;                // final phase
	psrlw      mm4, 15;                 // final phase
	psllw      mm4, 5;                  // final phase
	packuswb   mm4, mm4;                // final phase
	movd       ebx, mm4;                // final phase
	or         eax, ebx;                // final phase
	movd       mm4, [esi+40];           // final phase : ca[6]
	movd       mm6, [esi+72];           // final phase : cb[6]
	punpckldq  mm4, mm4;                // final phase
	punpckldq  mm6, mm6;                // final phase
	movq       mm5, mm4;                // final phase
	movq       mm7, mm6;                // final phase
	pcmpeqd    mm4, mm0;                // final phase
	pcmpeqd    mm5, mm1;                // final phase
	pcmpeqd    mm6, mm2;                // final phase
	pcmpeqd    mm7, mm3;                // final phase
	packssdw   mm4, mm5;                // final phase
	packssdw   mm6, mm7;                // final phase
	pand       mm4, mm6;                // final phase
	psrlw      mm4, 15;                 // final phase
	psllw      mm4, 6;                  // final phase
	packuswb   mm4, mm4;                // final phase
	movd       ebx, mm4;                // final phase
	or         eax, ebx;                // final phase
	movd       mm4, [esi+44];           // final phase : ca[7]
	movd       mm6, [esi+76];           // final phase : cb[7]
	punpckldq  mm4, mm4;                // final phase
	punpckldq  mm6, mm6;                // final phase
	movq       mm5, mm4;                // final phase
	movq       mm7, mm6;                // final phase
	pcmpeqd    mm4, mm0;                // final phase
	pcmpeqd    mm5, mm1;                // final phase
	pcmpeqd    mm6, mm2;                // final phase
	pcmpeqd    mm7, mm3;                // final phase
	packssdw   mm4, mm5;                // final phase
	packssdw   mm6, mm7;                // final phase
	pand       mm4, mm6;                // final phase
	psrlw      mm4, 15;                 // final phase
	psllw      mm4, 7;                  // final phase
	packuswb   mm4, mm4;                // final phase
	movd       ebx, mm4;                // final phase
	or         eax, ebx;                // final phase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; n
CHECK_C2_4KEY_MMX_LAST:
	mov        esp, [esp+48];

	pop        ebp;
	pop        edi;
	pop        esi;
	pop        edx;
	pop        ecx;
	pop        ebx;

	ret;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; nasm Ȃ̂łł܂
